/* 
Questionnaire sharing code
SLMPS 2021
v3

Goal: Take the .xslx from all the ODK-X questionnaires
Combine into two files, one household, one individual
Need to keep only the actual question sheets
Need to keep only the desired columns and rows

*/

*Key setup: copy all .xlsx into a "source" folder in this cd
*Make an "Eat" (temp) folder
*Survey must always be second sheet

*Directory
cd "/Users/Caroline/Dropbox/Sudan Labor Market Panel Survey (SLMPS)/Questionnaire sharing copies"

*cd "C:/Users/cgkrafft/Dropbox/Sudan Labor Market Panel Survey (SLMPS)/Questionnaire sharing copies"


*Temp -- hand adding: Lack of properties when formid not tableid b/c only in one -- had added in but had to take out for programming -- add to _update and 2_00_0

*Need to keep only the actual question sheets
*Need to keep only the desired columns
*Need to delete blank row


***************
*Loop import
***************

*List of files
local files_quest: dir "source" files "quest*.xlsx"
di `files_quest'

*For each quest file:
foreach file of local files_quest {

*List of questionnaire files
import excel "source/`file'", describe

/* Import excel, describe 
stores the following:

r(N_worksheet) number or worksheets in the Excel workbook
r(worksheet_#) name of worksheet # in the Excel workbook

*/

*Want sheet 2 (survey) and 8+
local sheet_min= cond(`r(N_worksheet)'<=7, 2,8)
local sheet_max= cond(`r(N_worksheet)'<=7, 2,`r(N_worksheet)')

di `sheet_min' `sheet_max'

*Import each sheet

foreach num of numlist 2 `sheet_min'/`sheet_max' {
	
*Revisit describe in loop
import excel "source/`file'", describe

*Local for filenames -- need to update this for substituting as needed

local out_name "`file'_`r(worksheet_`num')'"	
local out_name = subinstr("`out_name'", ".xlsx_survey","",.)	
*Fix to avoid dupe
local out_name = subinstr("`out_name'", "quest1_07_1_update.xlsx_7_1_Non_agriculture_ent","quest1_07_1_update.xlsx_7_1_Non_agro_ent",.)	

*This gets household and individual
local out_name = subinstr("`out_name'", "00_0.xlsx_1_","01_",.)	
local out_name = subinstr("`out_name'", "00_0.xlsx_2_","02_",.)	
local out_name = subinstr("`out_name'", "00_0.xlsx_3_","03_",.)	
local out_name = subinstr("`out_name'", "00_0.xlsx_4_","04_",.)	
local out_name = subinstr("`out_name'", "00_0.xlsx_5_","05_",.)	
local out_name = subinstr("`out_name'", "00_0.xlsx_6_","06_",.)	
local out_name = subinstr("`out_name'", "00_0.xlsx_7_","07_",.)	
local out_name = subinstr("`out_name'", "00_0.xlsx_8_","08_",.)	
local out_name = subinstr("`out_name'", "00_0.xlsx_9_","09_",.)	
local out_name = subinstr("`out_name'", "00_0.xlsx_","",.)	

*Sections in enterprise
local out_name = subinstr("`out_name'", "quest1_07_1_update.xlsx_","quest1_0",.)	

*Import sheet
import excel q_no=A eng_quest=B eng_hint=C eng_resp=D ar_quest=E ar_hint=F ar_resp=G  skips=H  using "source/`file'", ///
sheet(`r(worksheet_`num')') allstring clear

* Need to delete blank rows: Drop if all missing
drop if q_no=="" & eng_quest=="" & eng_hint==""  & eng_resp=="" & ar_quest=="" & ar_hint=="" & ar_resp=="" & skips==""

save "Eat/`out_name'.dta", replace
}
}


*********************************************
*Now need to use and export in correct order
*********************************************


*Household file
local files_questHH: dir "Eat" files "quest1_*"
local files_questHH: subinstr local files_questHH "_update.dta" "~update.dta", all
local files_questHH: subinstr local files_questHH ".dta" "`dta", all
local files_questHH: list sort files_questHH
local files_questHH: subinstr local files_questHH "`dta" ".dta", all
local files_questHH: subinstr local files_questHH "~update.dta" "_update.dta", all

di `files_questHH'

*For each quest file:
foreach fileHH of local files_questHH {

use "Eat/`fileHH'"

*Gets pissed if too long of a string for the sheet
local fileout= subinstr("`fileHH'",".dta","",.)
local fileout= cond(strlen(`"`fileout'"')>15, substr(`"`fileout'"',8,.), "`fileout'") 
local fileout= substr(`"`fileout'"',1,30)

di "`fileout'"
di strlen(`"`fileout'"')

export excel using "SLMPS_HH $S_DATE", sheet("`fileout'", replace)

}

*Individual file

local files_questI: dir "Eat" files "quest2_*"
local files_questI: subinstr local files_questI ".dta" "~dta", all
local files_questI: list sort files_questI
local files_questI: subinstr local files_questI "~dta" ".dta", all

di `files_questI'

*For each quest file:
foreach fileI of local files_questI {

use "Eat/`fileI'"

*Gets pissed if too long of a string for the shet
local fileout= subinstr("`fileI'",".dta","",.)
local fileout= cond(strlen(`"`fileout'"')>15, substr(`"`fileout'"',8,.), "`fileout'") 
local fileout= substr(`"`fileout'"',1,30)

di "`fileout'"

export excel using "SLMPS_Indiv $S_DATE", sheet("`fileout'", replace)

}

*Delete survey sheet
*quest1_07_1_Non_ag slightly out of order
*quest2_13_0 slightly out of order
*Select all sheets (right click, select all, or select first tab, hold shift, select last)
*Select full sheet 
*resize rows and columns (wrap text too)

